import React from 'react';
import ReactDOM from 'react-dom';
import PACK from './pack'
import { csv,nest } from 'd3'

class  App extends React.Component { 
  
   constructor(){
     super()
     this.state = { data: [] }
   }
 
   async getCSV(name){
     
     let table =  await csv(name)
     console.log(table)
   
     const process = table =>{
      
      const seperated =nest().key(d=> d.category).key(d=>d.gender).entries(table)
   
      
      const rename = (node)=> {
                     
                        node.forEach(n => {
                           if(n.key){
                               Object.keys(n).forEach(k => {
                                if(k=='key'){
                                   n['name'] = n[k]
                                   delete n[k]
                                }else{
                                   n['children'] = n[k]
                                   delete n[k]
                                }
                             }) 
                           }  
                           if(n.children)rename(n.children)
                        })
                      return node;
                    }
            let renamed = rename(seperated)
            let data = {}
            data['name'] = 'celebrities'
            data['children'] = renamed
            return data;
        }
     return process(table);
   } 
  
  
  render(){
     
     this.getCSV('celeb.csv').then(d => {
        this.setState({data:d})
     })
    
      return (<div className="message">
          <PACK/>
        </div>);
  }  

}

ReactDOM.render(<App />, document.getElementById('root'));
